/// @file
/// A task.

#include <sstream>
#include "MyTask.hh"



// ////////////////////////////////////////////////////////////////
// Constructor.
// ////////////////////////////////////////////////////////////////


MyTask::MyTask( sc_core::sc_module_name modulename,
                const task_id_t id,
                 Scnsl::Core::Node_t * n,
                const size_t proxies )
    throw ( std::invalid_argument ):
    // Parents:
   Scnsl::Tlm::TlmTask_if_t( modulename, id, n, proxies )
{
	SC_THREAD( writingProcess );
}

MyTask::~MyTask() throw() {}

void MyTask::writingProcess()
{
	
	while ( true )
	{
		byte_t i = byte_t( rand()%25 + 65 );
		
		const tlm_taskproxy_id_t tp = 0;
		const size_t s = 1;
		
		std::cout << "Time: " << sc_core::sc_time_stamp() << ", Name: " << name() << ", data sended: " << i;
		std::cout << ", packet size: " << s << " bytes" << std::endl;
		
		TlmTask_if_t::send( tp, &i, s);
		wait( 6000, sc_core::SC_US );
	}
}



void MyTask::b_transport( tlm::tlm_generic_payload & p, sc_core::sc_time & t ){

	t=t;
	char result;
	bool c;

	if(p.get_command() == Scnsl::Tlm::PACKET_COMMAND)
	{
    	result = static_cast< char >( * p.get_data_ptr() );
		std::cout << "Time: " << sc_core::sc_time_stamp() << ", Name: " << name() << ", data received: " << result;
		std::cout << ", packet size: " << p.get_data_length() << " bytes" << std::endl;
	}

	if(p.get_command() == Scnsl::Tlm::CARRIER_COMMAND)
	{
		c = * p.get_data_ptr();
		std::cout << "Time: " << sc_core::sc_time_stamp() << ", Name: " << name() << ", carrier: " << c << std::endl;
	}

}



