/// @file
/// A router task.

#include <sstream>

#include "TaskRouter2.hh"



// ////////////////////////////////////////////////////////////////
// Constructor.
// ////////////////////////////////////////////////////////////////

TaskRouter2::TaskRouter2( sc_core::sc_module_name modulename,
                		const task_id_t id,
                		Scnsl::Core::Node_t * n,
                		const size_t proxies )
    throw ( std::invalid_argument ):
    // Parents:
    Scnsl::Tlm::TlmTask_if_t( modulename, id, n, proxies )
{
	SC_THREAD( writingProcess );
}

TaskRouter2::~TaskRouter2() throw () {}

void TaskRouter2::writingProcess()
{

	/*while ( true )
	{
		byte_t i = byte_t( rand() % 25 + 65 );
		const tlm_taskproxy_id_t tp = 0;
		const size_t s = 1;
		label_t label = label_t( rand() % 2 );

		std::cout << "Time: " << sc_core::sc_time_stamp() << ", Name: " << name() << ", data sended: " << i;
		std::cout << ", packet size: " << s << " bytes, label: " << label << std::endl;

		TlmTask_if_t::send( tp, &i, s, label );
	}*/
}



void TaskRouter2::b_transport( tlm::tlm_generic_payload & p, sc_core::sc_time & t ){

	t=t;
	byte_t * result;
	bool c;
	Scnsl::Core::data_extension_t * ext;

	if(p.get_command() == Scnsl::Tlm::PACKET_COMMAND)
	{
		result = static_cast< byte_t *>( malloc ( p.get_data_length() ));
		memcpy( result, static_cast< unsigned char *>(p.get_data_ptr()), p.get_data_length());

		p.get_extension( ext );
		std::cout << "Time: " << sc_core::sc_time_stamp() << ", Name: " << name() << ", data received: " << result;
		std::cout << ", packet size: " << p.get_data_length() << " bytes, label: " << ext->label << std::endl;


		const tlm_taskproxy_id_t tp = ext->label;
		TlmTask_if_t::send( tp, result, p.get_data_length(), ext->label );

	}

	if(p.get_command() == Scnsl::Tlm::CARRIER_COMMAND)
	{
		c = * p.get_data_ptr();
		std::cout << "Time: " << sc_core::sc_time_stamp() << ", Name: " << name() << ", carrier: " << c << std::endl;
	}

}



