
#ifndef SCNSL__MY_TASK1_HH
#define SCNSL__MY_TASK1_HH



/// @file
/// Source node.


#include <systemc>
#include <tlm.h>


// Including the library:
#include <scnsl.hh>



class MyTask1 :
    public Scnsl::Tlm::TlmTask_if_t
{

public:

    SC_HAS_PROCESS( MyTask1 );

    /// @brief Constructor.
    ///
    /// @param name This module name.
    /// @param id this module unique ID.
    /// @param n The node on which this task is placed.
    /// @param proxies The number of connected task proxies.
	/// @param scenario The number that represents the type of communication between tasks, as described in README.txt.
    /// @throw std::invalid_argument If proxies is zero.
    ///
	MyTask1( sc_core::sc_module_name name,
             const task_id_t id,
             Scnsl::Core::Node_t * n,
             const size_t proxies,
			 const int scenario )
    	throw ( std::invalid_argument );

    virtual ~MyTask1() throw ();

	virtual void b_transport( tlm::tlm_generic_payload & p, sc_core::sc_time & t );

protected:

    /// @name Processes.
    //@{

    void writingProcess1();
    void writingProcess2();
    void writingProcess3();
    void writingProcess4();

    //@}

private:

    MyTask1( MyTask1 & );

    MyTask1 & operator = ( MyTask1 & );

};

#endif

