/// @file
/// A TLM task.

#include <sstream>

//#include "TlmTaskProxy_t.hh"
#include "MyTaskSender.hh"


//using Scnsl::Tlm::TlmTask_if_t;


// ////////////////////////////////////////////////////////////////
// Constructor.
// ////////////////////////////////////////////////////////////////

MyTaskSender::MyTaskSender( sc_core::sc_module_name modulename,
                            const task_id_t id,
                            Scnsl::Core::Node_t * n,
                            const size_t proxies )
    throw ( std::invalid_argument ):
    // Parents:
    Scnsl::Tlm::TlmTask_if_t( modulename, id, n, proxies )
{
	SC_THREAD( writingProcess );
}


MyTaskSender::~MyTaskSender() throw (){}


void MyTaskSender::writingProcess()
{

	while ( true )
	{
		byte_t i = byte_t( rand()%25 + 65 );
		const tlm_taskproxy_id_t tp = 0;
		const size_t s = 1;

        // Since we are tracing a complex message,
        // we wrap the log with the macro, to avoid
        // unuseful overhead.
#if ( SCNSL_LOG >= 1 )
        std::stringstream ss;
        ss << "data sent: " << i << " bytes: " << s;
        SCNSL_TRACE_LOG( 1, ss.str().c_str() );
#endif
		TlmTask_if_t::send( tp, &i, s, 0 );
	}
}


void MyTaskSender::b_transport( tlm::tlm_generic_payload & p, sc_core::sc_time & t ){

	t=t;
	bool c;

	if(p.get_command() == Scnsl::Tlm::CARRIER_COMMAND)
	{
		c = * p.get_data_ptr();

        // Since we are tracing a complex message,
        // we wrap the log with the macro, to avoid
        // unuseful overhead.
#if ( SCNSL_LOG >= 1 )
        std::stringstream ss;
        ss << "carrier: " << c;
        SCNSL_TRACE_LOG( 1, ss.str().c_str() );
#endif
	}

}



