/// @file
/// A TLM task.

#include <sstream>

#include "MyTaskReceiver.hh"


//using namespace Scnsl::Tlm;


// ////////////////////////////////////////////////////////////////
// Constructor.
// ////////////////////////////////////////////////////////////////

MyTaskReceiver::MyTaskReceiver( sc_core::sc_module_name modulename,
                                const task_id_t id,
                                Scnsl::Core::Node_t * n,
                                const size_t proxies )
    throw ( std::invalid_argument ):
    // Parents:
    Scnsl::Tlm::TlmTask_if_t( modulename, id, n, proxies )
{
}


MyTaskReceiver::~MyTaskReceiver() throw () {}


void MyTaskReceiver::b_transport( tlm::tlm_generic_payload & p, sc_core::sc_time & t )
{
	t=t;
	char result;
	bool c;
    size_t s;

	if(p.get_command() == Scnsl::Tlm::PACKET_COMMAND)
	{
    	result = static_cast< char >( * p.get_data_ptr() );
        s = p.get_data_length();

        // Since we are tracing a complex message,
        // we wrap the log with the macro, to avoid
        // unuseful overhead.
#if ( SCNSL_LOG >= 1 )
        std::stringstream ss;
        ss << "data received: " << result << " bytes: " << s;
        SCNSL_TRACE_LOG( 1, ss.str().c_str() );
#endif

	}

	if(p.get_command() == Scnsl::Tlm::CARRIER_COMMAND)
	{
		c = * p.get_data_ptr();

        // Since we are tracing a complex message,
        // we wrap the log with the macro, to avoid
        // unuseful overhead.
#if ( SCNSL_LOG >= 1 )
        std::stringstream ss;
        ss << "carrier: " << c;
        SCNSL_TRACE_LOG( 1, ss.str().c_str() );
#endif
	}
}



